---
title: RTCRtpStreamStats
slug: Web/API/RTCRtpStreamStats
tags:
  - API
  - Dictionary
  - Interface
  - RTCRtpStreamStats
  - RTP
  - Reference
  - Statistics
  - Stats
  - WebRTC
  - WebRTC API
  - rtc
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The {{domxref("RTCRtpStreamStats")}} dictionary is returned by the {{domxref("RTCPeerConnection.getStats()")}}, {{domxref("RTCRtpSender.getStats()")}}, and {{domxref("RTCRtpReceiver.getStats()")}} methods to provide detailed statistics about WebRTC connectivity.</span> While the dictionary has a base set of properties that are present in each of these cases, there are also additional properties added depending on which interface the method is called on.</p>

<p><code>RTCRtpStreamStats</code> is the base class for all RTP-related statistics reports. It's based on {{anch("RTCStats")}} and adds the following additional fields.</p>

<div class="note">
<p><strong>Note:</strong> This interface was called <code>RTCRTPStreamStats</code> until a specification update in the spring of 2017. Check the {{anch("Browser compatibility")}} table to know if and when the name change was implemented in specific browsers.</p>
</div>

<h2 id="Properties">Properties</h2>

<p><em>The <code>RTCRtpStreamStats</code> dictionary is based on {{domxref("RTCStats")}}, and inherits its properties. In addition, some or all of the following properties are available.</em></p>

<h3 id="Standard_fields_included_for_all_media_types">Standard fields included for all media types</h3>

<dl>
 <dt>{{domxref("RTCRtpStreamStats.codecId", "codecId")}}</dt>
 <dd>A {{domxref("DOMString")}} which uniquely identifies the object which was inspected to produce the {{domxref("RTCCodecStats")}} object associated with this {{Glossary("RTP")}} stream.</dd>
 <dt>{{domxref("RTCRtpStreamStats.kind", "kind")}}</dt>
 <dd>A {{domxref("DOMString")}} whose value is <code>"audio"</code> if the associated {{domxref("MediaStreamTrack")}} is audio-only or <code>"video"</code> if the track contains video. This value will match that of the media type indicated by {{domxref("RTCCodecStats.codec")}}, as well as the track's {{domxref("MediaStreamTrack.kind", "kind")}} property. Previously called <code>mediaType</code>.</dd>
 <dt>{{domxref("RTCRtpStreamStats.ssrc", "ssrc")}}</dt>
 <dd>The 32-bit integer which identifies the source of the RTP packets this <code>RTCRtpStreamStats</code> object covers. This value is generated per the {{RFC(3550)}} specification.</dd>
 <dt>{{domxref("RTCRtpStreamStats.trackId", "trackId")}}</dt>
 <dd>A {{domxref("DOMString")}} which uniquely identifies the {{domxref("RTCMediaStreamTrackStats")}} object representing the associated {{domxref("MediaStreamTrack")}}. This is <em>not</em> the same as the value of {{domxref("MediaStreamTrack.id")}}.</dd>
 <dt>{{domxref("RTCRtpStreamStats.transportId", "transportId")}}</dt>
 <dd>A {{domxref("DOMString")}} uniquely identifying the object which was inspected to produce the {{domxref("RTCTransportStats")}} object associated with this RTP stream.</dd>
 <dt>
 <h4 id="Obsolete_fields">Obsolete fields</h4>
 </dt>
 <dt>{{domxref("RTCRtpStreamStats.kind", "mediaType")}}</dt>
 <dd>Renamed to {{domxref("RTCRtpStreamStats.kind", "kind")}} in the specification in February 2018. See {{SectionOnPage("/en-US/docs/Web/API/RTCRtpStreamStats/kind", "Browser compatibility", "code")}} to determine when browsers made the transition.</dd>
</dl>

<h3 id="Local-only_measurements">Local-only measurements</h3>

<p>These properties are computed locally, and are only available to the device receiving the media stream. Their primary purpose is to examine the error resiliency of the connection, as they provide information about lost packets, lost frames, and how heavily compressed the data is.</p>

<dl>
 <dt>{{domxref("RTCRtpStreamStats.firCount", "firCount")}}</dt>
 <dd>A count of the total number of Full Intra Request (FIR) packets received by the sender. This statistic is only available to the device which is receiving the stream and is only available for video tracks. A FIR packet is sent by the receiving end of the stream when it falls behind or has lost packets and is unable to continue decoding the stream; the sending end of the stream receives the FIR packet and responds by sending a full frame instead of a delta frame, thereby letting the receiver "catch up." The higher this number is, the more often a problem of this nature arose, which can be a sign of network congestion or an overburdened receiving device.</dd>
 <dt>{{domxref("RTCRtpStreamStats.nackCount", "nackCount")}}</dt>
 <dd>The number of times the receiver notified the sender that one or more RTP packets has been lost by sending a Negative ACKnowledgement (NACK, also called "Generic NACK") packet to the sender. This value is only available to the receiver.</dd>
 <dt>{{domxref("RTCRtpStreamStats.pliCount", "pliCount")}}</dt>
 <dd>The number of times the receiving end of the stream sent a Picture Loss Indiciation (PLI) packet to the sender, indicating that it has lost some amount of encoded video data for one or more frames. Only the receiver has this value, and it's only valid for video tracks.</dd>
 <dt>{{domxref("RTCRtpStreamStats.qpSum", "qpSum")}}</dt>
 <dd>The sum of the Quantization Parameter (QP) values associated with every frame received to date on the video track described by this <code>RTCRtpStreamStats</code> object. In general, the higher this number is, the more heavily compressed the video track was. Combined with {{domxref("RTCReceivedRtpStreamStats.framesDecoded")}} or {{domxref("RTCSentRtpStreamStats.framesEncoded")}}, you can approximate the average QP over those frames, keeping in mind that codecs often vary the quantizer values even within frames. Also keep in mind that the values of QP can vary from codec to codec, so this value is only potentially useful when compared against the same codec.</dd>
 <dt>{{domxref("RTCRtpStreamStats.sliCount", "sliCount")}}</dt>
 <dd>The number of times the receiver notified the sender that one or more consecutive (in scan order) encoded video macroblocks have been lost or corrupted; this notification is sent by the receiver to the sender using a Slice Loss Indication (SLI) packet. This is a fairly technical part of how codecs work and while the higher this value is, the more errors occurred in the stream, generally most of the time this value is only interesting to very intensively hardcore media developers.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC Statistics Identifiers', '#streamstats-dict*', 'RTCRtpStreamStats')}}</td>
   <td>{{Spec2('WebRTC Statistics Identifiers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCRtpStreamStats")}}</p>
